from gtcdata.loader import gtcHistory
from gtcdata.visualizer import HistoryVisualizer as hv
import matplotlib.pyplot as plt
import numpy as np
import tkinter as tk


def histo_window(selfi, path, file_type=0):

    if file_type==0:
        filename = path+"/history.bp"
    elif file_type==1:
        filename = path+"/history.out"
    hisdata = gtcHistory(filename, verbose=True)

    myHV = hv(hisdata,selfi)
    # test lines:
    #print(myHV._data_file)
    #print(hisdata.data1de)
    #print(hisdata.data1de.shape)
    #print(hisdata.ndstep)


    ## functions for GUI

    ## GUI for plots

    window = tk.Toplevel(selfi)
    #window = tk.Tk()
    #window.pack_propagate(0) #prevent the window from shrinking
    window.title("History panel")
    # window.geometry('500x300')

    # Plot 1
    #lbl1 = tk.Label(window, text="Catagory 1", height=1, width=13)
    #lbl1.grid(column=0, row=0)
    def clicked1():
        myHV.plot_phi()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="phi", command=clicked1, height=1, width=10)
    btn1.grid(column=1, row=1)

    # Plot 2
    #lbl2 = tk.Label(window, text="Catagory 2", height=1, width=13)
    #lbl2.grid(column=0, row=1)
    def clicked2():
        myHV.plot_RMS_phi()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="phi RMS", command=clicked2, height=1, width=10)#, state='disabled')
    btn1.grid(column=1, row=2)
    
    ####
    def clicked3():
        myHV.plot_mode1_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode1 1", command=clicked3, height=1, width=10)
    btn1.grid(column=1, row=3)

    def clicked4():
        myHV.plot_mode2_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode2 1", command=clicked4, height=1, width=10)
    btn1.grid(column=1, row=4)

    def clicked5():
        myHV.plot_mode3_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode3 1", command=clicked5, height=1, width=10)
    btn1.grid(column=1, row=5)

    def clicked6():
        myHV.plot_mode4_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode4 1", command=clicked6, height=1, width=10)
    btn1.grid(column=1, row=6)

    def clicked7():
        myHV.plot_mode5_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode5 1", command=clicked7, height=1, width=10)
    btn1.grid(column=1, row=7)

    def clicked8():
        myHV.plot_mode6_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode6 1", command=clicked8, height=1, width=10)
    btn1.grid(column=1, row=8)

    def clicked9():
        myHV.plot_mode7_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode7 1", command=clicked9, height=1, width=10)
    btn1.grid(column=1, row=9)

    def clicked10():
        myHV.plot_mode8_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode8 1", command=clicked10, height=1, width=10)
    btn1.grid(column=1, row=10)

    #############

    def clicked11():
        myHV.plot_apara()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="apara", command=clicked11, height=1, width=10)#, state='disabled')
    btn1.grid(column=2, row=1)

    def clicked12():
        myHV.plot_RMS_apara()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="apara RMS", command=clicked12, height=1, width=10)#, state='disabled')
    btn1.grid(column=2, row=2)

    ####
    def clicked13():
        myHV.plot_mode1_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode1 2", command=clicked13, height=1, width=10)
    btn1.grid(column=2, row=3)

    def clicked14():
        myHV.plot_mode2_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode2 2", command=clicked14, height=1, width=10)
    btn1.grid(column=2, row=4)

    def clicked15():
        myHV.plot_mode3_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode3 2", command=clicked15, height=1, width=10)
    btn1.grid(column=2, row=5)

    def clicked16():
        myHV.plot_mode4_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode4 2", command=clicked16, height=1, width=10)
    btn1.grid(column=2, row=6)

    def clicked17():
        myHV.plot_mode5_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode5 2", command=clicked17, height=1, width=10)
    btn1.grid(column=2, row=7)

    def clicked18():
        myHV.plot_mode6_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode6 2", command=clicked18, height=1, width=10)
    btn1.grid(column=2, row=8)

    def clicked19():
        myHV.plot_mode7_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode7 2", command=clicked19, height=1, width=10)
    btn1.grid(column=2, row=9)

    def clicked20():
        myHV.plot_mode8_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode8 2", command=clicked20, height=1, width=10)
    btn1.grid(column=2, row=10)

    #############

    def clicked21():
        myHV.plot_fluidne()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="fluidne", command=clicked21, height=1, width=10)#, state='disabled')
    btn1.grid(column=3, row=1)

    def clicked22():
        myHV.plot_RMS_fluidne()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="fluidne RMS", command=clicked22, height=1, width=10)#, state='disabled')
    btn1.grid(column=3, row=2)

    ####
    def clicked23():
        myHV.plot_mode1_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode1 3", command=clicked23, height=1, width=10)
    btn1.grid(column=3, row=3)

    def clicked24():
        myHV.plot_mode2_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode2 3", command=clicked24, height=1, width=10)
    btn1.grid(column=3, row=4)

    def clicked25():
        myHV.plot_mode3_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode3 3", command=clicked25, height=1, width=10)
    btn1.grid(column=3, row=5)

    def clicked26():
        myHV.plot_mode4_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode4 3", command=clicked26, height=1, width=10)
    btn1.grid(column=3, row=6)

    def clicked27():
        myHV.plot_mode5_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode5 3", command=clicked27, height=1, width=10)
    btn1.grid(column=3, row=7)

    def clicked28():
        myHV.plot_mode6_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode6 3", command=clicked28, height=1, width=10)
    btn1.grid(column=3, row=8)

    def clicked29():
        myHV.plot_mode7_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode7 3", command=clicked29, height=1, width=10)
    btn1.grid(column=3, row=9)

    def clicked30():
        myHV.plot_mode8_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="mode8 3", command=clicked30, height=1, width=10)
    btn1.grid(column=3, row=10)

    #############

    def clicked31():
        myHV.plot_ion_den()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="ion density", command=clicked31, height=1, width=10)
    btn1.grid(column=4, row=1)

    def clicked32():
        myHV.plot_ion_mom()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="ion momentum", command=clicked32, height=1, width=10)
    btn1.grid(column=4, row=2)

    def clicked33():
        myHV.plot_ion_ene()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="ion energy", command=clicked33, height=1, width=10)
    btn1.grid(column=4, row=3)

    def clicked34():
        myHV.plot_ion_mom_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="ion pmflux", command=clicked34, height=1, width=10)
    btn1.grid(column=4, row=4)

    def clicked35():
        myHV.plot_ion_ene_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="ion eflux", command=clicked35, height=1, width=10)
    btn1.grid(column=4, row=5)

    #############

    def clicked36():
        myHV.plot_ep_den()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="EP density", command=clicked36, height=1, width=10)
    btn1.grid(column=4, row=6)

    def clicked37():
        myHV.plot_ep_mom()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="EP momentum", command=clicked37, height=1, width=10)
    btn1.grid(column=4, row=7)

    def clicked38():
        myHV.plot_ep_ene()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="EP energy", command=clicked38, height=1, width=10)
    btn1.grid(column=4, row=8)

    def clicked39():
        myHV.plot_ep_mom_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="EP pmflux", command=clicked39, height=1, width=10)
    btn1.grid(column=4, row=9)

    def clicked40():
        myHV.plot_ep_ene_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="EP eflux", command=clicked40, height=1, width=10)
    btn1.grid(column=4, row=10)

    #############

    def clicked41():
        myHV.plot_ele_den()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="e- density", command=clicked41, height=1, width=10)
    btn1.grid(column=5, row=1)

    def clicked42():
        myHV.plot_ele_mom()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="e- momentum", command=clicked42, height=1, width=10)
    btn1.grid(column=5, row=2)

    def clicked43():
        myHV.plot_ele_ene()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="e- energy", command=clicked43, height=1, width=10)
    btn1.grid(column=5, row=3)

    def clicked44():
        myHV.plot_ele_mom_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="e- pmflux", command=clicked44, height=1, width=10)
    btn1.grid(column=5, row=4)

    def clicked45():
        myHV.plot_ele_ene_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="e- eflux", command=clicked45, height=1, width=10)
    btn1.grid(column=5, row=5)



    #######################################

    #change the time range for the plot
    var_nstart = tk.StringVar()
    txt_nstart = tk.Entry(window,width=10,textvariable=var_nstart)
    txt_nstart.grid(column=8, row=1)
    var_nstart.set(myHV.nstart)
    var_nend = tk.StringVar()
    txt_nend = tk.Entry(window,width=10,textvariable=var_nend)
    txt_nend.grid(column=9, row=1)
    var_nend.set(myHV.nend)
    def clicked_trange():
        if var_nstart.get()=="" or var_nend.get()=="":
            var_nstart.set(myHV.nstart)
            var_nend.set(myHV.nend)
        else:
            myHV.nstart = int(var_nstart.get())
            myHV.nend = int(var_nend.get())
    btn_edit = tk.Button(window, text="time range", command=clicked_trange, height=1, width=10)
    btn_edit.grid(column=7, row=1)

    lb_trange = tk.Label(window, text = "range: ("+ str(myHV.nstart) +', '+ str(myHV.nend) +')')
    lb_trange.grid(column = 10, row = 1)

    #######################################

    #select the method to refresh figures
    select_plt = tk.IntVar() 
    select_plt.set(0)
    def click_slct():
        myHV.plot_mode = int(select_plt.get())
        if myHV.plot_mode == 1:
            print('plot mode changes to "New Figs"')
        elif myHV.plot_mode == 0:
            print('plot mode changes to "Refresh"')
        else:
            print('error: wrong input for plot mode')
    rad1 = tk.Radiobutton(window,text='New Figs', value=1, 
                        variable=select_plt, command=click_slct, width=10)
    rad1.grid(column=7, row=4)
    rad2 = tk.Radiobutton(window,text='Refresh', value=0, 
                        variable=select_plt, command=click_slct, width=10)
    rad2.grid(column=8, row=4)

    #######################################

    # Button to reset all settings of the main window
    def click_reset():
        myHV.nstart = 0
        var_nstart.set(myHV.nstart)
        myHV.nend = myHV._data.ndstep-1
        var_nend.set(myHV.nend)

        myHV.plot_mode = 0
        select_plt.set(0)
    btn_reset = tk.Button(window, text="reset", fg="red", 
                          command=click_reset, height=1, width=10)
    btn_reset.grid(column=12, row=13)

    # Button to quit the main window
    btn_quit = tk.Button(window, text="Quit", fg="red", 
                        command=window.destroy, height=1, width=10)
    btn_quit.grid(column=13, row=13)

    window.mainloop()

    ## test functions

    #myEV.print_test()
    #input("press Enter...")

    #plt.show(block=False)
    #input("press Enter to close plots")

